module RabbitMQ::Definition
  class Command
    attr_accessor :client, :verbose

    def self.run(*args)
      new(*args).execute
    end

    def initialize(client, verbose)
      @client = client
      @verbose = !!verbose
    end

    def execute
      raise NotImplementedError
    end

    protected

    def uri_endpoint
      @uri_endpoint ||= URI.parse(client.endpoint)
    end

    def user
      uri_endpoint.user
    end

    def add_permissions_for_vhost(vhost)
      client.update_permissions_of(vhost, user, {
        :configure => ".*",
        :write     => ".*",
        :read       => ".*"
      })
    end
  end
end
