module RabbitMQ::Definition
  class Load < Command
    def execute
      if !FileDefinition.exists?
        Logger.error "No definition with vhosts exists"
      else
        definition = FileDefinition.read
        Logger.progress "Uploading definition..."
        client.upload_definitions(definition.to_json)
        ensure_permissions(definition)
        Logger.success "Done"
      end
    end

    private

    def ensure_permissions(definition)
      definition.vhosts.each do |vhost|
        add_permissions_for_vhost(vhost['name'])
      end
    end
  end
end
