namespace :rabbitmq do
  def retrieve_vhosts
    ENV["VHOSTS"] ? ENV["VHOSTS"].split(",") : nil
  end

  desc "Create a RabbitMQ schema for a vhost (comma separated vhosts)"
  task :create do |t, args|
    RabbitMQ::Definition.create(retrieve_vhosts)
  end

  desc "Drop all RabbitMQ queues/exchanges/bindings"
  task :drop do
    RabbitMQ::Definition.drop
  end

  desc "Dump RabbitMQ JSON structure (from defined vhosts or supplied comma separated vhosts) "
  task :dump do |t, args|
    RabbitMQ::Definition.dump(retrieve_vhosts)
  end

  desc "Load RabbitMQ JSON structure"
  task :load do
    RabbitMQ::Definition.load
  end
end
